﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Imaging;

namespace WindowsFormsApplication1
{
    public partial class frmTextToImage : Form
    {
        public frmTextToImage()
        {
            InitializeComponent();
        }

        public Color FontColor { get; set; }
        public Color FontBackColor { get; set; }
        public string FontName { get; set; }
        public string ImagePath { get; set; }
        public int FontSize { get; set; }
        public int ImageHeight { get; set; }
        public int ImageWidth { get; set; }
        public Bitmap ImageText { get; set; }
        public Graphics ImageGraphics { get; set; }
        public Font ImageFont { get; set; }
        public SolidBrush BrushForeColor { get; set; }
        public SolidBrush BrushBackColor { get; set; }
        public PointF ImagePointF { get; set; }




        private void DrawText(string text)
        {
            richTextBox1.Select(1, 4);
            FontColor = richTextBox1.SelectionColor;
            FontBackColor = richTextBox1.SelectionBackColor;
            FontName = "Arial";// richTextBox1.SelectionFont.Name;
            FontSize = 20; //Convert.ToInt16(richTextBox1.SelectionFont.Size);
            ImageHeight = richTextBox1.Height;
            ImageWidth = richTextBox1.Width;
            ImagePath = @"D:\WaleedImageTest.JPEG";
            ImageText = new Bitmap(ImageWidth, ImageHeight);

            ImageGraphics = Graphics.FromImage(ImageText);

            ImageFont = new Font(FontName, FontSize);
            ImagePointF = new PointF(5, 5);
            BrushForeColor = new SolidBrush(FontColor);
            BrushBackColor = new SolidBrush(FontBackColor);

            ImageGraphics.FillRectangle(BrushBackColor, 0, 0, ImageWidth, ImageHeight);
            ImageGraphics.DrawString(text, ImageFont, BrushForeColor, ImagePointF);

            string outputFileName = ImagePath;
            using (MemoryStream memory = new MemoryStream())
            {
                using (FileStream fs = new FileStream(outputFileName, FileMode.Create, FileAccess.ReadWrite))
                {
                    ImageText.Save(memory, ImageFormat.Jpeg);
                    byte[] bytes = memory.ToArray();
                    fs.Write(bytes, 0, bytes.Length);
                }
            }

            MessageBox.Show("Please find newly created image at  -> D:\\WaleedImageTest.JPEG");

            //ImageText.Save(ImagePath, ImageFormat.Jpeg);
        }

        private void cmdMakeTextToImage_Click(object sender, EventArgs e)
        {
            DrawText(richTextBox1.Text);
        }
    }
}
